

#define u32 unsigned long 

#include <string.h>


u32 key[8] = {0,0,0,0,0,0,0,0};




int __stdcall __export setup (u32 *keydata[8])
{
memmove (&key[0], &keydata[0],32);
return 0;
}





int  __stdcall __export crypt (u32 *ap, u32 *bp)
{
u32 a=*ap;
u32 b=*bp;
u32 r;

for (r=0;r<64;r++)
{

 b+=a+((a<<6)^(a>>8))+ (key[r%8]+r);
 r++;
 a+=b+((b<<6)^(b>>8))+ (key[r%8]+r);
}

*ap= a;
*bp= b;


return 0;
}


int  __stdcall __export decrypt (u32 *ap, u32 *bp)
{
u32 a=*ap;
u32 b=*bp;
long r;

for (r=63;r>=0;r--)
{
 a-=b+((b<<6)^(b>>8))+ (key[r%8]+r);
 r--;
 b-=a+((a<<6)^(a>>8))+ (key[r%8]+r);

}

*ap= a;
*bp= b;


return 0;
}






int __stdcall __export xteacrypt(u32 *ap, u32 *bp) {
    unsigned int num_rounds = 64;
    unsigned long v0=*ap, v1=*bp, i;
    unsigned long sum=0, delta=0x9E3779B9;
    for(i=0; i<num_rounds; i++) {
       v0 += (((v1 << 4) ^ (v1 >> 5)) + v1) ^ (sum + key[sum & 3]);
        sum += delta;
        v1 += (((v0 << 4) ^ (v0 >> 5)) + v0) ^ (sum + key[(sum>>11) & 3]);
    }
*ap= v0;
*bp= v1;

return 0;
}
 
int __stdcall __export xteadecrypt (u32 *ap, u32 *bp) {
    unsigned int num_rounds = 64;
    unsigned long v0=*ap, v1=*bp, i;
    unsigned long delta=0x9E3779B9, sum=delta*num_rounds;
    for(i=0; i<num_rounds; i++) {
        v1 -= (((v0 << 4) ^ (v0 >> 5)) + v0) ^ (sum + key[(sum>>11) & 3]);
        sum -= delta;
        v0 -= (((v1 << 4) ^ (v1 >> 5)) + v1) ^ (sum + key[sum & 3]);
    }
*ap= v0;
*bp= v1;

return 0;
}
